<?php

function msup_scim_user_provisioning(){
	$currenttab = "sp_config";
	?>

    <div id="msup_scim_up_settings">
        <h2> SCIM user provisioning </h2>
        <div class="miniorange_container">
            <table style="width:100%;">
                <tr>
                    <h2 class="nav-tab-wrapper">
                        <a class="nav-tab <?php if ( $currenttab == 'sp_config' ) {
							echo 'nav-tab-active';
						} ?> "href="<?php echo esc_url('admin.php?page=user_provisioning&tab=sp_config');?> ">SCIM Configuration</a>
                    </h2>

                    <td style="vertical-align:top;width:65%;">
						<?php  
						if ( $currenttab == 'sp_config' ) {
							msup_scim_user_provisioning_configuration();
                        }
						?>
                    </td>
                </tr>
            </table>
        </div>
    </div>
		<?php
    }


/* show plugin settings page */
function msup_scim_user_provisioning_configuration() {
	?>

    <div class="msup_table_layout">
		<?php $scim_idp_name = !empty(get_site_option('msup_scim_idp_name')) ? get_site_option('msup_scim_idp_name') : 'onelogin';
        echo '
        <div class="msup_scim_up_table_layout" style="padding-bottom:5px;!important">
            <div style="display:block;margin-top:10px;background-color:rgba(255, 255, 255, 255);padding:5px;border:solid 1px rgba(255, 255, 255, 255);">
                <h2>SCIM Configuration</h2>
                <hr>
                
                <form method="post" action="">
                    <input type="hidden" name="option" value="msup_scim_select_idp_option">';
                        wp_nonce_field('msup_scim_idp_name_option');
        echo '
                    <table width="60%" style="padding: 10px;">
                        <tr>
                            <td style="30%"><b>Select your Identity provider:</b></td>
                            <td>
                                <select name="msup_scim_idp_name" id ="msup_scim_idp_name" style="width: 100%">';
                                    echo '<option value="onelogin"';
                                    if($scim_idp_name == 'onelogin'){
                                        echo ' selected';
                                    }
                                    echo '>OneLogin</option>';

                                    echo '<option value="okta"';
                                    if($scim_idp_name == 'okta'){
                                        echo ' selected';
                                    }
                                    echo '>Okta</option>';

                                    echo '<option value="azuread"';
                                    if($scim_idp_name == 'azuread'){
                                        echo ' selected';
                                    }
                                    echo '>Azure AD</option>';

                                    echo '<option value="other"';
                                    if($scim_idp_name == 'other'){
                                        echo ' selected';
                                    }
                                    echo '>Other</option>
                                </select>
                            </td> 
                        </tr>
                        <tr>
                            <td><br/><br/></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td colspan="2">
                                <input type="submit" value="Save" class="button button-primary button-large">
                            </td>
                        </tr>
                    </table>
                </form>
            </div>
        </div>
        <div>
             <div class="msup_scim_up_table_layout" style="padding-bottom:50px;!important">   
                <form name="f" style="margin-left:6px;" method="post" action="">
                    <input type="hidden" name="option" value="generate_new_token_option" />';
                    wp_nonce_field('generate_new_token_option_nonce');
            echo '  <h3>SCIM API Credentials: </h3>
                    <table border="1" style="background-color:#FFFFFF; border:1px solid #CCCCCC; padding:0px 0px 0px 10px; margin:2px; border-collapse: collapse; width:98%">
                        <tr>
                            <td style="width:40%; padding: 15px;"><b>SCIM Base URL</b></td>
                            <td style="width:60%; padding: 15px;">'. esc_url(site_url()) . '/scim</td> 
                        </tr>
                        <tr>
                            <td style="width:40%; padding: 15px;"><b>SCIM Bearer Token</b> 
                                <span style="padding-left:16px;">
                                    <input type="submit" class="button" value="Generate New token">
                                </span>
                            </td>';
                            if(get_site_option('msup_scim_up_bearer_token') == ""){
                                $bearer_token=msup_scim_create_bearer_token();
                            } else {
                                $get_bearer = get_site_option('msup_scim_up_bearer_token');
                                $bearer_token = convert_uudecode($get_bearer);
                            }
            echo '          <td style="width:60%; padding: 15px;">
                                '. esc_html($bearer_token) . '
                            </td>
                        </tr>
                    </table>
                </form>
            </div>
        </div><br>
        <div>
            <div class="msup_scim_up_table_layout" style="padding-bottom:50px;!important">
                <div style="display:block;margin-top:10px;background-color:rgba(255, 255, 255, 255);padding:5px;border:solid 1px rgba(255, 255, 255, 255);">
                    <h2>SCIM Operations</h2><hr>
                    <table border="1" style="background-color:#FFFFFF; border:1px solid #CCCCCC; padding:0px 0px 0px 10px; margin:2px; border-collapse: collapse; width:98%">
                        <tr><b>Create:</b>
                        <ol>It will create users using First Name, Email and Username.</ol>
                        </tr>
                    </table>
                </div>
            </div>
        </div>';
}

/* create new bearer token for authentication */
function msup_scim_create_bearer_token()
{
    $bearer_token = bin2hex(random_bytes(32));
    update_site_option('msup_scim_up_bearer_token',convert_uuencode($bearer_token));
    return $bearer_token;
}

/* This function checks if scim endpoint is called then validate bearer token and perform user operations.*/
function msup_scim_user_provisioning_validate() {
    if(strpos($_SERVER['REQUEST_URI'], "/scim") !== false) {
        
        $get_bearer = get_site_option('msup_scim_up_bearer_token');
        $bearer_token = convert_uudecode($get_bearer);
        $bearer = msup_scim_getBearerToken(); 
        if($bearer!==$bearer_token) {
            echo esc_html('Invalid Authorization.');
            exit;
        }
        $post = file_get_contents('php://input');
        $json = json_decode($post, true);
        $scimUserId = '';
        $isUserProvsioningRequest = false;

        if(strpos($_SERVER['REQUEST_URI'], "/scim/Users") !== false || strpos($_SERVER['REQUEST_URI'], "/scim/v2/Users") !== false){
            $isUserProvsioningRequest = true;
        }

        if(strpos($_SERVER['REQUEST_URI'], "/scim/Users/") !== false || strpos($_SERVER['REQUEST_URI'], "/scim/v2/Users/") !== false){
            $scimUserId=sanitize_text_field(substr($_SERVER['REQUEST_URI'], strpos($_SERVER['REQUEST_URI'], "Users/")+6));
        }

        if($isUserProvsioningRequest){
            msup_scim_handle_user_request($json, $scimUserId);
        }
        header("HTTP/1.1 200 OK");
        header('Content-Type: application/json;charset=utf-8');
        $json_data = '{
            "schemas": ["urn:ietf:params:scim:api:messages:2.0:ListResponse"],
           "totalResults": 0,
           "startIndex": 1,
           "itemsPerPage": 0,
           "Resources": []
       }';
        echo($json_data);
        exit;
    }
}


/* This function observe scim/user endpoint and performs action requested from identity provider.*/
function msup_scim_handle_user_request($json, $scimid){
    $username = sanitize_textarea_field($json['userName']);
    $givenName = sanitize_textarea_field($json['name']['givenName']);
    $email = sanitize_email($json['emails'][0]['value']);
    if(empty($username))
        $username = $email;
    $uid = username_exists($username);

    if((strpos($_SERVER['REQUEST_METHOD'], "PUT") !== false || strpos($_SERVER['REQUEST_METHOD'], "PATCH") !== false ) and !empty($scimid)) {
        wp_update_user( array('ID' => $uid, 'first_name' => $givenName) );
        if (isset($json['active']) && !empty($json['active'])){                     
            $active = sanitize_text_field($json['active']);
        }
        elseif (isset($json['Operations'][0]['path'])) {                         
            if ($json['Operations'][0]['path'] == 'active' ) {
                $active = sanitize_text_field($json['Operations'][0]['value']);
            }
        } elseif(isset($json['Operations'][0]['value']['active'])){             
            $active = sanitize_text_field($json['Operations'][0]['value']['active']);
        } else {
            $active = 'update';
        }


        $user = get_user_by('id', $scimid);
       
        msup_send_user_details($user, true);

    } elseif(strpos($_SERVER['REQUEST_METHOD'], "POST") !== false)  {
        if(username_exists($username) || email_exists($email)){     
            if(username_exists($username)){
                $user = get_user_by('login', $username);
                $uid = $user->ID;
            } else if(email_exists($email)){
                $user 	= get_user_by('email', $email );
                $uid = $user->ID;
            }
            $json['id'] = $uid;
            $json['meta'] = array('resourceType' => 'User');
            $json = json_encode($json);
            header("HTTP/1.1 201 Created");
            header('Content-Type: application/json;charset=utf-8');
            echo($json);
            exit;
        } else {
            $random_password = wp_generate_password( 10, false );
            if(isset($json['password']) and !empty($json['password'])){
                $scim_password = sanitize_text_field($json['password']);
            }
            if(!empty($scim_password))
                $random_password = $scim_password;
            $uid = wp_create_user( $username, $random_password, $email );
            if($uid){
                wp_update_user( array('ID' => $uid, 'first_name' => $givenName) );
                update_user_meta($uid, 'msup_scim_user_status', 'active');
                $json['id'] = $uid;
                $json['meta'] = array('resourceType' => 'User');
                $json = json_encode($json);
                header("HTTP/1.1 201 Created");
                header('Content-Type: application/json;charset=utf-8');
                echo($json);
                exit;
            }
        }
    }  
}

/* This function returns valid response to Identity Provider if user update is successful. */
function msup_send_user_details($user, $active){
$json_data = '{
            "schemas": ["urn:ietf:params:scim:schemas:core:2.0:User"],
            "id": "'.$user->ID.'",
            "userName": "'.$user->user_login.'",
            "active": '.$active.',
            "emails": [{
                "primary": true,
                "value": "'.$user->user_email.'",
                "type": "work",
                "display": "'.$user->user_email.'"
            }],
            "groups": [],
            "meta": {
                "resourceType": "User"
            }
        }';

        header("HTTP/1.1 200 OK");
        header('Content-Type: application/json;charset=utf-8');
        echo($json_data);

        exit;
}

/* This function retrieves authorization header from SCIM request.*/
function msup_getAuthorizationHeader(){
    $headers = null;
    if (isset($_SERVER['Authorization'])) {
        $headers = trim($_SERVER["Authorization"]);
    }
    else if (isset($_SERVER['HTTP_AUTHORIZATION'])) { 
        $headers = trim($_SERVER["HTTP_AUTHORIZATION"]);
    } elseif (function_exists('apache_request_headers')) {
        $requestHeaders = apache_request_headers();
        $requestHeaders = array_combine(array_map('ucwords', array_keys($requestHeaders)), array_values($requestHeaders));
        if (isset($requestHeaders['Authorization'])) {
            $headers = trim($requestHeaders['Authorization']);
        }
    }
    return $headers;
}

function msup_scim_getBearerToken() {
    $headers = msup_getAuthorizationHeader();
    if (!empty($headers)) {
        if (preg_match('/Bearer\s(\S+)/', $headers, $matches)) {
            return $matches[1];
        }
    }
    return null;
}
